<!DOCTYPE html>
<html lang="en" xml:lang="en-GB" xmlns="http://www.w3.org/1999/xhtml" xmlns:dct="http://purl.org/dc/terms/" xmlns:cc="http://creativecommons.org/ns#">
<head>
  <meta http-equiv="Content-Type" content="application/xhtml+xml; charset=utf-8" />
  <title>Test Pages for textarea and label</title>
  <meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=yes" />
  <link rel="stylesheet" type="text/css" media="screen" href="../../../css/verdemoderna.css" title="default" />
  <link rel="top" href="../../../index.html" title="Accessibility Works: Home page" />
  <meta name="robots" content="noindex, nofollow" />
  <style type="text/css">
    textarea { display: block; }
  </style>
</head>
<body>
  <header id="header">
    <h1><span class="h1txt">Test Pages for <code>textarea</code> and <code>label</code></span></h1>
  </header>

  <main id="main">
    <p>This page contains examples of <code>textarea</code> elements with <code>label</code> elements,
      sometimes explicitly associated with each other, sometimes not.
      Question: If the <code>label</code> element is wrapped around the <code>textarea</code> element,
      does the <code>textarea</code> element's content become part of the accessible name?
      This is not entirely obvious when reading the
      <a href="https://www.w3.org/TR/html-aam-1.0/#accessible-name-and-description-computation">accessible name and description computation algorithm</a>.
      In addition, implementation in screen readers may vary.
    </p>
    <p><code>textarea</code> element inside a <code>form</code> element:</p>
    <form action="index.html" method="post" enctype="multipart/form-data" name="freetext">
      <p><label for="freetext-1">Label explicitly associated</label>
        <textarea id="freetext-1" cols="40" rows="2"></textarea>
      </p>
      <p><label for="freetext-2">Label explicitly associated</label>
        <textarea id="freetext-2" cols="40" rows="2">freetext-2 data</textarea>
      </p>
      <p><label>Label wraps around texarea
        <textarea id="freetext-3" cols="40" rows="2"></textarea>
        </label>
      </p>
      <p><label>Label wraps around texarea
        <textarea id="freetext-4" cols="40" rows="2">freetext-4 data</textarea>
        </label>
      </p>
    </form>
  
    <p><code>textarea</code> element inside a <code>div</code> element with <code>aria-label</code>
    instead of a <code>form</code> element:</p>
    <div aria-label="a random aria-label">
      <p><label for="divtext-1">Label explicitly associated</label>
        <textarea id="divtext-1" cols="40" rows="2"></textarea>
      </p>
      <p><label for="divtext-2">Label explicitly associated</label>
        <textarea id="divtext-2" cols="40" rows="2">divtext-2 data</textarea>
      </p>
      <p><label>Label wraps around texarea
        <textarea id="divtext-3" cols="40" rows="2"></textarea>
        </label>
      </p>
      <p><label>Label wraps around texarea
        <textarea id="divtext-4" cols="40" rows="2">divtext-4 data</textarea>
        </label>
      </p>
    </div>

    <p>Findings from 22 July 2020:</p>
    <ul>
      <li>When tabbing through the page using Firefox 78.02 and <abbr>NVDA</abbr> 2019.3.1 (Windows 10),
        the labels are always read as expected. Text inside the <code>textarea</code>
        elements is read in a slightly different voice than the labels.
        <abbr>NVDA</abbr> does not read the value of the <code>aria-label</code> attribute on the <code>div</code> element.
      </li>
      <li>When tabbing through the page using Microsoft Edge and <abbr>NVDA</abbr> 2019.3.1 (Windows 10),
        the labels are always read as expected. Text inside the <code>textarea</code>
        elements is read in a slightly different voice than the labels.
        <abbr>NVDA</abbr> also reads the value of the <code>aria-label</code> attribute on the <code>div</code> element.
      </li>
      <li>When tabbing through the page using Google Chrome 84.0.4147.89 and <abbr>NVDA</abbr> 2019.3.1 (Windows 10),
        the labels are always read as expected. Text inside the <code>textarea</code>
        elements is read in a slightly different voice than the labels.
        <abbr>NVDA</abbr> does not read the value of the <code>aria-label</code> attribute on the <code>div</code> element.
        <br />(In fields where Chrome detects spelling errors (visible as red wavy lines below the relevant words),
        <abbr>NVDA</abbr> also announces the spelling error before reading the relevant word containing the error.
      </li>
      <li>When tabbing through the page using Firefox 78.02 and Windows Narrator (Windows 10),
        the labels are always read as expected.
        Narrator does not read the value of the <code>aria-label</code> attribute on the <code>div</code> element.
        <br />(After initially loading the page, Narrator starts reading the entire page from top to bottom;
        each of the labels is read twice.)
      </li>
      <li>When tabbing through the page using Google Chrome 84.0.4147.89 and Windows Narrator (Windows 10),
        the labels are always read as expected.
        Narrator does not read the value of the <code>aria-label</code> attribute on the <code>div</code> element.
        <br />(After initially loading the page, Narrator starts reading the entire page from top to bottom;
        each of the labels is read twice.)
      </li>
      <li>When tabbing through the page using Microsoft Edge and Windows Narrator (Windows 10),
        the labels are always read as expected.
        Narrator also reads the value of the <code>aria-label</code> attribute on the <code>div</code> element.
        <br />(After initially loading the page, Narrator does not start reading the entire page from top to bottom.)
      </li>
    </ul>

    <p>See also:</p>
    <ul>
      <li>
        <a href="https://www.w3.org/WAI/tutorials/forms/labels/">Labeling Controls</a>,
        <i class="website">Web Accessibility Tutorials, <abbr>W3C</abbr> Web Accessibility Initiative</i>.
      </li>
      <li>
        <a href="https://webaim.org/articles/label-name/">Decoding Label and Name for Accessibility</a>,
        <i class="website">Web<abbr>AIM</abbr></i>, 28.02.2020 (latest update).
      </li>
      <li>
        <a href="https://dequeuniversity.com/rules/axe/3.5/label?application=axeAPI">Form &lt;input&gt; elements must have labels</a>,
        <i class="website">Deque University</i>.
      </li>
      <li>
        <a href="https://ux.stackexchange.com/questions/35289/input-checkboxes-wrapped-inside-labels">Input checkboxes wrapped inside &lt;labels&gt;</a>,
        <i class="website">User Experience Stack Exchange</i>, question submitted on 22.02.2013.
      </li>
      <li>
        <a href="https://stackoverflow.com/questions/774054/should-i-put-input-elements-inside-a-label-element">Should I put input elements inside a label element?</a>,
        <i class="website">Stack Overflow</i>, question submitted on 21.04.2009.
        Most of the answers don't take accessibility into account.
      </li>
    </ul>

  </main>

  <footer id="footer">
    <p id="licence">
    <a class="image" rel="license" href="http://creativecommons.org/licenses/by-sa/4.0/">
    <img alt="Creative Commons License Attribution-ShareAlike" style="border-width:0" src="../../../img/cc-licence-by-sa-88x31.png" />
    </a>
    <br />
    <span xmlns:dct="http://purl.org/dc/terms/" href="http://purl.org/dc/dcmitype/Text">
    <a href="https://cstrobbe.gitlab.io/A11yWorks/">Accessibility
    Works</a></span> by <a xmlns:cc="http://creativecommons.org/ns#"
    href="https://gitlab.com/cstrobbe"
    rel="cc:attributionURL">Christophe Strobbe</a> is licensed under a <a
    xml:lang="en-US" lang="en-US" rel="license"
    href="http://creativecommons.org/licenses/by-sa/4.0/">Creative Commons
    Attribution-ShareAlike 4.0 International License</a>. </p>

    <p><a href="../../../sitemap.html">Site map</a>.</p>
    <p>You can <a href="https://gitlab.com/cstrobbe/A11yWorks">fork the code</a> on GitLab.</p>
  </footer>
</body>
</html>